#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <sys/types.h>
#include <string.h>
#include <tcp.h>
#include "vncdos.h"

tcp_Socket vncsock;

int main(int argc, char * argv[])
{
	int port = DEF_PORT;
	char *host = "192.168.77.77";
	int k;

	if (argc>=2) host = argv[1];
	if (argc>=3) port = atoi(argv[2]);


//	dbug_init();
	sock_init();

	if (!vncproto_init(&vncsock, host, port)) {
		perror("vncproto_init:");
		return 0;
	}

	if (video_init() == -1) {
		perror("video_init():");
		sock_close(&vncsock);
		return 0;
	}

	if (request_vnc_refresh(&vncsock) == -1) {
		perror("first VNC refresh error:");
		return 0;
	}
	
	dbug_printf("while(1)\n");		
	while(tcp_tick(&vncsock)) {
		if (kbhit()) {
			if ((k=getch())==0) k = 256 + getch();
			if (!parse_kbd_in(k, &vncsock)) {
				dbug_printf("keyboard break\n");		
				break;
			}
		}
		if(sock_dataready(&vncsock))
			parse_vnc_in(&vncsock);
		else
			request_vnc_refresh(&vncsock);
	}

	sock_close(&vncsock);

	return 0;
}
